<?php
/**
 * Created by PhpStorm.
 * User: matheusalves
 * Date: 15/01/2016
 * Time: 07:35
 */

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\MAN\Services;


class GetFiliais extends CrudWithParameterBag{

    protected $dataSourceName = 'filiais-lojaturnosave';

    protected $dataSourceFindSelect = 'filiais-loja';
    protected $dataSourceP  = 'filiais-lojaturno';
    protected $dataSourceSave = 'filiais-lojaturnosave';
    protected $parameterBagColumns = array('NRORG');
    protected $connection;

    public function __construct(Manager $dataSourceManager, Connection $connection, ParameterBag $parameterBag, Services\GetFiliais $FiliaisTurnoService) {
        $this->FiliaisTurnoService =  $FiliaisTurnoService;
        $this->connection = $connection;
        parent::__construct($dataSourceManager, $parameterBag);
    }

    public function save(Request\DataSet $request, Response $response){
        // $request->getDataSet()->getRows();
        // $rowa = $request->getDataSet()->getRows();
        // $isnew = $rowa[0]['__is_new'];
        // try{
        //     $this->connection->beginTransaction();
        //     foreach ($rowa[0]['FILILOJA'] as $row) {
        //         $rowfilial = explode("_", $row);
        //         if (isset($rowfilial[1])) {
        //             $rowa[0]['CDFILIAL'] = $rowfilial[0];
        //             $rowa[0]['CDLOJA'] = $rowfilial[1];
        //             if ($isnew) {
        //                $rowa[0]['NRRELACIONAMENTO'] = $this->FiliaisTurnoService->getNextId();
        //             }
        //             parent::save($request, $response);
        //             $rowa[0]['CDFILIAL'] = '';
        //             $rowa[0]['CDLOJA'] = '';
        //         }
        //         else {
        //             $rowa[0]['CDFILIAL'] = $rowfilial[0];
        //             if ($isnew) {
        //                $rowa[0]['NRRELACIONAMENTO'] = $this->FiliaisTurnoService->getNextId();
        //             }
        //             parent::save($request, $response);
        //         }
        //     }
        //     $this->connection->commit();
        // } catch(\Exception $e){
        //     $message = $e->getMessage();
        //     $this->connection->rollBack();
        // }

        foreach($request->getDataSet()->getRows() as &$row) {
            foreach($row['FILILOJA'] as $fililoja){
                $cods = explode('_', $fililoja);
                $row['CDFILIAL'] = $cods[0];
                if(!isset($cods[1])){
                    $row['CDLOJA'] = null;
                } else if(isset($cods[1])){
                    $row['CDLOJA'] = $cods[1];
                }
                $row['DTINCLUSAO'] = date("d/m/Y H:i:s");
                $row['DTULTATU'] = date("d/m/Y H:i:s");

                if($row['CDLOJA'] == null) {
                    $insereFili = $this->FiliaisTurnoService->validaFilial($row['NRSEQTURNO'], $row['CDFILIAL'], $row['NRORG']);
                    $insereLoja['valida'] = \Service\GetFiliais::INSERE_LOJA;
                    if($insereFili['valida'] == \Service\GetFiliais::FILIAL_INATIVA){
                        $row['__is_new'] = false;
                        $row['IDATIVO'] = 'S';
                        $row['NRRELACIONAMENTO'] = $insereFili['NRRELACIONAMENTO'];
                        $request->getDataSet()->setDataSourceName('filiais-lojaturnoatu');
                        $this->dataSourceManager->persist($request->getDataSet());
                        $response->addDataSet(new DataSet('resp', array(true)));
                    } else{
                        $response->addDataSet(new DataSet('resp', array(false)));
                    }
                }
                if($row['CDLOJA'] != null){
                    $insereFili = $this->FiliaisTurnoService->validaFilial($row['NRSEQTURNO'], $row['CDFILIAL'], $row['NRORG']);
                    $insereLoja = $this->FiliaisTurnoService->validaLoja($row['NRSEQTURNO'], $row['CDFILIAL'], $row['CDLOJA'], $row['NRORG']);
                    if($insereFili['valida'] == \Service\GetFiliais::FILIAL_ATIVA && $insereLoja['valida'] == \Service\GetFiliais::INSERE_LOJA){
                        $insereFili['valida'] = \Service\GetFiliais::INSERE_FILIAL;
                    } else if($insereFili['valida'] == \Service\GetFiliais::INSERE_FILIAL && $insereLoja['valida'] == \Service\GetFiliais::INSERE_LOJA){
                        $row['__is_new'] = true;
                        $aux = $row['CDLOJA'];
                        $row['CDLOJA'] = null;
                        $row['NRRELACIONAMENTO'] = $this->FiliaisTurnoService->getNextId();
                        $request->getDataSet()->setDataSourceName('filiais-lojaturnosave');
                        $this->dataSourceManager->persist($request->getDataSet());
                        $row['CDLOJA'] = $aux;
                    } else if($insereFili['valida'] == \Service\GetFiliais::FILIAL_INATIVA && $insereLoja['valida'] == \Service\GetFiliais::INSERE_LOJA) {
                        $row['__is_new'] = false;
                        $row['IDATIVO'] = 'S';
                        $aux = $row['CDLOJA'];
                        $row['CDLOJA'] = null;
                        $row['NRRELACIONAMENTO'] = $insereFili['NRRELACIONAMENTO'];
                        $request->getDataSet()->setDataSourceName('filiais-lojaturnoatu');
                        $this->dataSourceManager->persist($request->getDataSet());
                        $row['CDLOJA'] = $aux;
                        $insereFili['valida'] = \Service\GetFiliais::INSERE_FILIAL;
                    } else if($insereFili['valida'] == \Service\GetFiliais::FILIAL_INATIVA && $insereLoja['valida'] == \Service\GetFiliais::LOJA_INATIVA) {
                        $row['__is_new'] = false;
                        $row['IDATIVO'] = 'S';
                        $aux = $row['CDLOJA'];
                        $row['CDLOJA'] = null;
                        $row['NRRELACIONAMENTO'] = $insereFili['NRRELACIONAMENTO'];
                        $request->getDataSet()->setDataSourceName('filiais-lojaturnoatu');
                        $this->dataSourceManager->persist($request->getDataSet());
                        $row['CDLOJA'] = $aux;
                        $row['NRRELACIONAMENTO'] = $insereLoja['NRRELACIONAMENTO'];
                        $this->dataSourceManager->persist($request->getDataSet());
                        $response->addDataSet(new DataSet('resp', array(true)));
                    } else if($insereFili['valida'] == \Service\GetFiliais::FILIAL_ATIVA && $insereLoja['valida'] == \Service\GetFiliais::LOJA_INATIVA) {
                        $row['__is_new'] = false;
                        $row['IDATIVO'] = 'S';
                        $row['NRRELACIONAMENTO'] = $insereLoja['NRRELACIONAMENTO'];
                        $request->getDataSet()->setDataSourceName('filiais-lojaturnoatu');
                        $this->dataSourceManager->persist($request->getDataSet());
                        $response->addDataSet(new DataSet('resp', array(true)));
                    } else{
                        $response->addDataSet(new DataSet('resp', array(false)));
                    }
                }
                if($insereFili['valida'] == \Service\GetFiliais::INSERE_FILIAL && $insereLoja['valida'] == \Service\GetFiliais::INSERE_LOJA){
                    $row['__is_new'] = true;
                    $row['NRRELACIONAMENTO'] = $this->FiliaisTurnoService->getNextId();
                    $request->getDataSet()->setDataSourceName('filiais-lojaturnosave');
                    $this->dataSourceManager->persist($request->getDataSet());
                    $response->addDataSet(new DataSet('resp', array(true)));
                }
            }
        }
    }

    public function find(Request\Filter $request, Response $response){
        $this->dataSourceName = $this->dataSourceP;
        parent::find($request, $response);
        $this->dataSourceName = $this->dataSourceSave;
    }

    public function findSelect(Request\Filter $request, Response $response){
        $this->dataSourceName = $this->dataSourceFindSelect;
        parent::find($request, $response);
        $this->dataSourceName = $this->dataSourceSave;
    }
    
    public function delete(Request\DataSet $request, Response $response){
        foreach($request->getDataSet()->getRows() as &$row){
            $row['DTULTATU'] = date("d/m/Y H:i:s");
            $row['__is_new'] = false;
            if($row['CDLOJA'] === null) {
                $this->dataSourceManager->persist(new DataSet('filiais-lojaturnoatu', array($row)));
                $lojas = $this->FiliaisTurnoService->getFilialPorLoja($row['NRSEQTURNO'], $row['CDFILIAL'], $row['NRORG']);
                if($lojas != 1){
                    foreach ($lojas as $loja) {
                        $row['CDLOJA'] = $loja['CDLOJA'];
                        $row['NRRELACIONAMENTO'] = $loja['NRRELACIONAMENTO'];
                        $this->dataSourceManager->persist(new DataSet('filiais-lojaturnoatu', array($row)));
                    }
                }
            } else {
                $this->dataSourceManager->persist(new DataSet('filiais-lojaturnoatu', array($row)));
            }       
        }
    }

    /*
    Retorna tree de filial, loja e pdv por nrorg
    */
    public function getFiliaisByNrorg(Request\Filter $request, Response $response){
    	$retorno = $request->getFilterCriteria()->getConditions();
        $nrorg   = $retorno[0]['value'];
        $relacionamento = $retorno[1]['value'];
        $param = array('NRORG'=>$nrorg);
        if($relacionamento == 'PDV'){
    		$filiais = $this->FiliaisTurnoService->getFiliaisByNrorg($param);
        }else if ($relacionamento == 'FILIAL'){
        	$filiais = $this->FiliaisTurnoService->getFiliais($param);
        }else{
    		$filiais = $this->FiliaisTurnoService->getFiliaisLojasByNrorg($param);
        }
    	$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getFiliaisByNrorg', $filiais));
    	return $filiais;
    }
 
    /*
    Retorna tree de filial, loja pdv por nrorg
    */
    public function getFiliaisLojasByNrorg(Request\Filter $request, Response $response){
		$retorno = $request->getFilterCriteria()->getConditions();
        $nrorg   = $retorno[0]['value'];
        $param = array('NRORG'=>$nrorg);
    	$filiais = $this->FiliaisTurnoService->getFiliaisLojasByNrorg($param);
    	$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getFiliaisLojasByNrorg', $filiais));
    	return $filiais;
	}

}